/// @addtogroup auxil
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file random.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

inline double random(double d){
  return double (std::rand())*d/RAND_MAX;
}

inline int random(int d){
  return int (std::rand())*d/RAND_MAX;
}

inline void randomStart(int n=0){
   if(!n) n=std::time(0);
   std::srand(n);
}
